diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/matrix-array.cc ns-3.42/src/core/model/matrix-array.cc
--- ns-3.41/src/core/model/matrix-array.cc	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/matrix-array.cc	2024-05-29 15:29:46.932073000 -0700
@@ -158,6 +158,70 @@
 
 template <class T>
 MatrixArray<T>
+MatrixArray<T>::Determinant() const
+{
+    MatrixArray<T> res{1, 1, m_numPages};
+    NS_ASSERT_MSG(m_numRows == m_numCols, "Matrix is not square");
+    // In case of small matrices, we use a fast path
+    if (m_numRows == 1)
+    {
+        return *this;
+    }
+    // Calculate determinant for each matrix
+    for (size_t page = 0; page < m_numPages; ++page)
+    {
+        res(0, 0, page) = 0;
+        auto pageValues = GetPagePtr(page);
+
+        // Fast path for 2x2 matrices
+        if (m_numRows == 2)
+        {
+            res(0, 0, page) = pageValues[0] * pageValues[3] - pageValues[1] * pageValues[2];
+            continue;
+        }
+        for (size_t detN = 0; detN < m_numRows; detN++)
+        {
+            auto partDetP = T{0} + 1.0;
+            auto partDetN = T{0} + 1.0;
+            for (size_t row = 0; row < m_numRows; row++)
+            {
+                // Wraparound not to have to extend the matrix
+                // Positive determinant
+                size_t col = (row + detN) % m_numCols;
+                partDetP *= pageValues[row * m_numCols + col];
+
+                // Negative determinant
+                col = m_numCols - 1 - (row + detN) % m_numCols;
+                partDetN *= pageValues[row * m_numCols + col];
+            }
+            res(0, 0, page) += partDetP - partDetN;
+        }
+    }
+    return res;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::FrobeniusNorm() const
+{
+    MatrixArray<T> res{1, 1, m_numPages};
+    for (size_t page = 0; page < m_numPages; ++page)
+    {
+        // Calculate the sum of squared absolute values of each matrix page
+        res[page] = 0;
+        auto pagePtr = this->GetPagePtr(page);
+        for (size_t i = 0; i < m_numRows * m_numCols; i++)
+        {
+            auto absVal = std::abs(pagePtr[i]);
+            res[page] += absVal * absVal;
+        }
+        res[page] = sqrt(res[page]);
+    }
+    return res;
+}
+
+template <class T>
+MatrixArray<T>
 MatrixArray<T>::MultiplyByLeftAndRightMatrix(const MatrixArray<T>& lMatrix,
                                              const MatrixArray<T>& rMatrix) const
 {
@@ -229,6 +293,84 @@
     return retMatrix;
 }
 
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::MakeNCopies(size_t nCopies) const
+{
+    NS_ASSERT_MSG(m_numPages == 1, "The MatrixArray should have only one page to be copied.");
+    auto copiedMatrix = MatrixArray<T>{m_numRows, m_numCols, nCopies};
+    for (size_t copy = 0; copy < nCopies; copy++)
+    {
+        for (size_t i = 0; i < m_numRows * m_numCols; i++)
+        {
+            copiedMatrix.GetPagePtr(copy)[i] = m_values[i];
+        }
+    }
+    return copiedMatrix;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::ExtractPage(size_t page) const
+{
+    NS_ASSERT_MSG(page < m_numPages, "The page to extract from the MatrixArray is out of bounds.");
+    auto extractedPage = MatrixArray<T>{m_numRows, m_numCols, 1};
+
+    for (size_t i = 0; i < m_numRows * m_numCols; ++i)
+    {
+        extractedPage.m_values[i] = GetPagePtr(page)[i];
+    }
+    return extractedPage;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::JoinPages(const std::vector<MatrixArray<T>>& pages)
+{
+    auto jointMatrix =
+        MatrixArray<T>{pages.front().GetNumRows(), pages.front().GetNumCols(), pages.size()};
+    for (size_t page = 0; page < jointMatrix.GetNumPages(); page++)
+    {
+        NS_ASSERT_MSG(pages[page].GetNumRows() == jointMatrix.GetNumRows(),
+                      "All page matrices should have the same number of rows");
+        NS_ASSERT_MSG(pages[page].GetNumCols() == jointMatrix.GetNumCols(),
+                      "All page matrices should have the same number of columns");
+        NS_ASSERT_MSG(pages[page].GetNumPages() == 1,
+                      "All page matrices should have a single page");
+
+        size_t i = 0;
+        for (auto a : pages[page].GetValues())
+        {
+            jointMatrix.GetPagePtr(page)[i] = a;
+            i++;
+        }
+    }
+    return jointMatrix;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::IdentityMatrix(const size_t size, const size_t pages)
+{
+    auto identityMatrix = MatrixArray<T>{size, size, pages};
+    for (std::size_t page = 0; page < pages; page++)
+    {
+        for (std::size_t i = 0; i < size; i++)
+        {
+            identityMatrix(i, i, page) = 1.0;
+        }
+    }
+    return identityMatrix;
+}
+
+template <class T>
+MatrixArray<T>
+MatrixArray<T>::IdentityMatrix(const MatrixArray& likeme)
+{
+    NS_ASSERT_MSG(likeme.GetNumRows() == likeme.GetNumCols(), "Template array is not square.");
+    return IdentityMatrix(likeme.GetNumRows(), likeme.GetNumPages());
+}
+
 template MatrixArray<std::complex<double>> MatrixArray<std::complex<double>>::HermitianTranspose()
     const;
 template class MatrixArray<std::complex<double>>;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/matrix-array.h ns-3.42/src/core/model/matrix-array.h
--- ns-3.41/src/core/model/matrix-array.h	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/matrix-array.h	2024-05-29 15:29:46.932073000 -0700
@@ -190,6 +190,16 @@
      */
     MatrixArray Transpose() const;
     /**
+     * \brief This operator calculates a vector o determinants, one for each page
+     * \return The resulting MatrixArray with the determinants for each page.
+     */
+    MatrixArray Determinant() const;
+    /**
+     * \brief This operator calculates a vector of Frobenius norm, one for each page
+     * \return The resulting MatrixArray with the Frobenius norm for each page.
+     */
+    MatrixArray FrobeniusNorm() const;
+    /**
      *\brief Multiply each matrix in the array by the left and the right matrix.
      * For each page of this MatrixArray the operation performed is
      * lMatrix * matrix(pageIndex) * rMatrix, and the resulting MatrixArray<T>
@@ -229,6 +239,40 @@
               typename = std::enable_if_t<(std::is_same_v<T, std::complex<double>> && EnableBool)>>
     MatrixArray<T> HermitianTranspose() const;
 
+    /**
+     * \brief Function that copies the current 1-page matrix into a new matrix with n copies of the
+     * original matrix
+     * \param nCopies Number of copies to make of the input 1-page MatrixArray
+     * \return Returns a new matrix with n page copies
+     */
+    MatrixArray<T> MakeNCopies(size_t nCopies) const;
+    /**
+     * \brief Function extracts a page from a MatrixArray
+     * \param page Index of the page to be extracted from the n-page MatrixArray
+     * \return Returns an extracted page of the original MatrixArray
+     */
+    MatrixArray<T> ExtractPage(size_t page) const;
+    /**
+     * \brief Function joins multiple pages into a single MatrixArray
+     * \param pages Vector containing n 1-page MatrixArrays to be merged into a n-page MatrixArray
+     * \return Returns a joint MatrixArray
+     */
+    static MatrixArray<T> JoinPages(const std::vector<MatrixArray<T>>& pages);
+    /**
+     * \brief Function produces an identity MatrixArray with the specified size
+     * \param size Size of the output identity matrix
+     * \param pages Number of copies of the identity matrix
+     * \return Returns an identity MatrixArray
+     */
+    static MatrixArray<T> IdentityMatrix(const size_t size, const size_t pages = 1);
+    /**
+     * \brief Function produces an identity MatrixArray with the same size
+     * as the input MatrixArray
+     * \param likeme Input matrix used to determine the size of the identity matrix
+     * \return Returns an identity MatrixArray
+     */
+    static MatrixArray<T> IdentityMatrix(const MatrixArray& likeme);
+
   protected:
     // To simplify functions in MatrixArray that are using members from the template base class
     using ValArray<T>::m_numRows;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/nstime.h ns-3.42/src/core/model/nstime.h
--- ns-3.41/src/core/model/nstime.h	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/nstime.h	2024-05-29 15:29:46.932073000 -0700
@@ -841,13 +841,6 @@
 } // namespace TracedValueCallback
 
 /**
- * Force static initialization order of Time in each compilation unit.
- * This is internal to the Time implementation.
- * \relates Time
- */
-static bool g_TimeStaticInit [[maybe_unused]] = Time::StaticInit();
-
-/**
  * Equality operator for Time.
  * \param [in] lhs The first value
  * \param [in] rhs The second value
@@ -1414,9 +1407,9 @@
 ATTRIBUTE_ACCESSOR_DEFINE(Time);
 
 /**
- *  \ingroup attribute_time
- *  Helper to make a Time checker with bounded range.
- *  Both limits are inclusive
+ * \ingroup attribute_Time
+ * Helper to make a Time checker with bounded range.
+ * Both limits are inclusive
  *
  * \param [in] min Minimum allowed value.
  * \param [in] max Maximum allowed value.
@@ -1425,7 +1418,7 @@
 Ptr<const AttributeChecker> MakeTimeChecker(const Time min, const Time max);
 
 /**
- * \ingroup attribute_time
+ * \ingroup attribute_Time
  * Helper to make an unbounded Time checker.
  *
  * \return The AttributeChecker
@@ -1437,7 +1430,7 @@
 }
 
 /**
- * \ingroup attribute_time
+ * \ingroup attribute_Time
  * Helper to make a Time checker with a lower bound.
  *
  * \param [in] min Minimum allowed value.
@@ -1490,6 +1483,27 @@
  */
 TYPENAMEGET_DEFINE(Time);
 
+/**
+ * \ingroup time
+ *
+ * \brief Helper class to force static initialization
+ * of Time in each compilation unit, ensuring it is
+ * initialized before usage.
+ * This is internal to the Time implementation.
+ * \relates Time
+ */
+class TimeInitializationHelper
+{
+  public:
+    /** Default constructor calls Time::StaticInit */
+    TimeInitializationHelper()
+    {
+        Time::StaticInit();
+    }
+};
+
+static TimeInitializationHelper g_timeInitHelper; ///< Instance of Time static initialization helper
+
 } // namespace ns3
 
 #endif /* TIME_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/object-base.cc ns-3.42/src/core/model/object-base.cc
--- ns-3.41/src/core/model/object-base.cc	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/object-base.cc	2024-05-29 15:29:46.932073000 -0700
@@ -36,6 +36,13 @@
 namespace ns3
 {
 // Explicit instantiation declaration
+
+/**
+ * \ingroup callback
+ * Explicit instantiation for ObjectBase
+ * \return A wrapper Callback
+ * \sa ns3::MakeCallback
+ */
 template Callback<ObjectBase*> MakeCallback<ObjectBase*>(ObjectBase* (*)());
 template Callback<ObjectBase*>::Callback();
 template class CallbackImpl<ObjectBase*>;
@@ -319,6 +326,7 @@
     Ptr<const TraceSourceAccessor> accessor = tid.LookupTraceSourceByName(name);
     if (!accessor)
     {
+        NS_LOG_DEBUG("Cannot connect trace " << name << " on object of type " << tid.GetName());
         return false;
     }
     bool ok = accessor->ConnectWithoutContext(this, cb);
@@ -333,6 +341,7 @@
     Ptr<const TraceSourceAccessor> accessor = tid.LookupTraceSourceByName(name);
     if (!accessor)
     {
+        NS_LOG_DEBUG("Cannot connect trace " << name << " on object of type " << tid.GetName());
         return false;
     }
     bool ok = accessor->Connect(this, context, cb);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/object.cc ns-3.42/src/core/model/object.cc
--- ns-3.41/src/core/model/object.cc	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/object.cc	2024-05-29 15:29:46.932073000 -0700
@@ -59,16 +59,27 @@
 Object::AggregateIterator::HasNext() const
 {
     NS_LOG_FUNCTION(this);
-    return m_current < m_object->m_aggregates->n;
+    return (m_current < m_object->m_aggregates->n) ||
+           (m_uniAggrIter != m_object->m_unidirectionalAggregates.end());
 }
 
 Ptr<const Object>
 Object::AggregateIterator::Next()
 {
     NS_LOG_FUNCTION(this);
-    Object* object = m_object->m_aggregates->buffer[m_current];
-    m_current++;
-    return object;
+    if (m_current < m_object->m_aggregates->n)
+    {
+        Object* object = m_object->m_aggregates->buffer[m_current];
+        m_current++;
+        return object;
+    }
+    else if (m_uniAggrIter != m_object->m_unidirectionalAggregates.end())
+    {
+        auto object = *m_uniAggrIter;
+        m_uniAggrIter++;
+        return object;
+    }
+    return nullptr;
 }
 
 Object::AggregateIterator::AggregateIterator(Ptr<const Object> object)
@@ -76,6 +87,7 @@
       m_current(0)
 {
     NS_LOG_FUNCTION(this << object);
+    m_uniAggrIter = object->m_unidirectionalAggregates.begin();
 }
 
 TypeId
@@ -127,6 +139,7 @@
         std::free(m_aggregates);
     }
     m_aggregates = nullptr;
+    m_unidirectionalAggregates.clear();
 }
 
 Object::Object(const Object& o)
@@ -153,6 +166,7 @@
     NS_LOG_FUNCTION(this << tid);
     NS_ASSERT(CheckLoose());
 
+    // First check if the object is in the normal aggregates.
     uint32_t n = m_aggregates->n;
     TypeId objectTid = Object::GetTypeId();
     for (uint32_t i = 0; i < n; i++)
@@ -179,6 +193,20 @@
             return const_cast<Object*>(current);
         }
     }
+
+    // Next check if it's a unidirectional aggregate
+    for (auto& uniItem : m_unidirectionalAggregates)
+    {
+        TypeId cur = uniItem->GetInstanceTypeId();
+        while (cur != tid && cur != objectTid)
+        {
+            cur = cur.GetParent();
+        }
+        if (cur == tid)
+        {
+            return uniItem;
+        }
+    }
     return nullptr;
 }
 
@@ -206,6 +234,17 @@
             goto restart;
         }
     }
+
+    // note: no need to restart because unidirectionally aggregated objects
+    // can not change the status of the actual object.
+    for (auto& uniItem : m_unidirectionalAggregates)
+    {
+        if (!uniItem->m_initialized)
+        {
+            uniItem->DoInitialize();
+            uniItem->m_initialized = true;
+        }
+    }
 }
 
 bool
@@ -239,6 +278,17 @@
             goto restart;
         }
     }
+
+    // note: no need to restart because unidirectionally aggregated objects
+    // can not change the status of the actual object.
+    for (auto& uniItem : m_unidirectionalAggregates)
+    {
+        if (!uniItem->m_disposed && uniItem->GetReferenceCount() == 1)
+        {
+            uniItem->DoDispose();
+            uniItem->m_disposed = true;
+        }
+    }
 }
 
 void
@@ -280,11 +330,13 @@
     {
         aggregates->buffer[m_aggregates->n + i] = other->m_aggregates->buffer[i];
         const TypeId typeId = other->m_aggregates->buffer[i]->GetInstanceTypeId();
+        // note: DoGetObject scans also the unidirectional aggregates
         if (DoGetObject(typeId))
         {
             NS_FATAL_ERROR("Object::AggregateObject(): "
                            "Multiple aggregation of objects of type "
-                           << other->GetInstanceTypeId() << " on objects of type " << typeId);
+                           << other->GetInstanceTypeId() << " on objects of type "
+                           << GetInstanceTypeId());
         }
         UpdateSortedArray(aggregates, m_aggregates->n + i);
     }
@@ -323,7 +375,47 @@
     std::free(b);
 }
 
-/**
+void
+Object::UnidirectionalAggregateObject(Ptr<Object> o)
+{
+    NS_LOG_FUNCTION(this << o);
+    NS_ASSERT(!m_disposed);
+    NS_ASSERT(!o->m_disposed);
+    NS_ASSERT(CheckLoose());
+    NS_ASSERT(o->CheckLoose());
+
+    Object* other = PeekPointer(o);
+
+    const TypeId typeId = other->GetInstanceTypeId();
+    // note: DoGetObject scans also the unidirectional aggregates
+    if (DoGetObject(typeId))
+    {
+        NS_FATAL_ERROR("Object::UnidirectionalAggregateObject(): "
+                       "Multiple aggregation of objects of type "
+                       << other->GetInstanceTypeId() << " on objects of type "
+                       << GetInstanceTypeId());
+    }
+
+    m_unidirectionalAggregates.emplace_back(other);
+
+    // Finally, call NotifyNewAggregate on all the objects aggregates by this object.
+    // We skip the aggregated Object and its aggregates because they are not
+    // mutually aggregated to the others.
+    // Unfortunately, we have to make a copy of the aggregated objects, because
+    // NotifyNewAggregate might change it...
+
+    std::list<Object*> aggregates;
+    for (uint32_t i = 0; i < m_aggregates->n; i++)
+    {
+        aggregates.emplace_back(m_aggregates->buffer[i]);
+    }
+    for (auto& item : aggregates)
+    {
+        item->NotifyNewAggregate();
+    }
+}
+
+/*
  * This function must be implemented in the stack that needs to notify
  * other stacks connected to the node of their presence in the node.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/object-factory.cc ns-3.42/src/core/model/object-factory.cc
--- ns-3.41/src/core/model/object-factory.cc	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/object-factory.cc	2024-05-29 15:29:46.932073000 -0700
@@ -93,6 +93,9 @@
 ObjectFactory::Create() const
 {
     NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(
+        m_tid.GetUid(),
+        "ObjectFactory::Create - can't use an ObjectFactory without setting a TypeId first.");
     Callback<ObjectBase*> cb = m_tid.GetConstructor();
     ObjectBase* base = cb();
     auto derived = dynamic_cast<Object*>(base);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/object-factory.h ns-3.42/src/core/model/object-factory.h
--- ns-3.41/src/core/model/object-factory.h	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/object-factory.h	2024-05-29 15:29:46.932073000 -0700
@@ -205,7 +205,11 @@
 ObjectFactory::Create() const
 {
     Ptr<Object> object = Create();
-    return object->GetObject<T>();
+    auto obj = object->GetObject<T>();
+    NS_ASSERT_MSG(obj != nullptr,
+                  "ObjectFactory::Create error: incompatible types ("
+                      << T::GetTypeId().GetName() << " and " << object->GetInstanceTypeId() << ")");
+    return obj;
 }
 
 template <typename... Args>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/object.h ns-3.42/src/core/model/object.h
--- ns-3.41/src/core/model/object.h	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/object.h	2024-05-29 15:29:46.932073000 -0700
@@ -137,6 +137,8 @@
         AggregateIterator(Ptr<const Object> object);
         Ptr<const Object> m_object; //!< Parent Object.
         uint32_t m_current;         //!< Current position in parent's aggregates.
+        /// Iterator to the unidirectional aggregates.
+        std::vector<Ptr<Object>>::const_iterator m_uniAggrIter;
     };
 
     /** Constructor. */
@@ -200,6 +202,44 @@
     void AggregateObject(Ptr<Object> other);
 
     /**
+     * Aggregate an Object to another Object.
+     *
+     * \param [in] other The other Object pointer
+     *
+     * This method aggregates the an object to another Object:
+     * after this method returns, it becomes possible to call GetObject()
+     * on the aggregating Object to get the other, but not vice-versa.
+     *
+     * This method calls the virtual method NotifyNewAggregates() to
+     * notify all aggregated Objects that they have been aggregated
+     * together.
+     *
+     * This method is useful only if there is the need to aggregate an
+     * object to more than one object at the same time, and should be avoided
+     * if not strictly necessary.
+     * In particular, objects aggregated with this method should be destroyed
+     * only after making sure that the objects they are aggregated to are
+     * destroyed as well. However, the destruction of the aggregating objects
+     * will take care of the unidirectional aggregated objects gracefully.
+     *
+     * Beware that an object aggregated to another with this function
+     * behaves differently than other aggregates in the following ways.
+     * Suppose that Object B is aggregated unidirectionally:
+     *   - It can be aggregated unidirectionally to more than one objects
+     *     (e.g., A1 and A2).
+     *   - It is not possible to call GetObject on B to find an aggregate of
+     *     object A1 or A2.
+     *   - When A1 or A2 are initialized, B is initialized, whichever happens first.
+     *   - When A1 or A2 are destroyed, B is destroyed, whichever happens last.
+     *   - If B is initialized, A1 and A2 are unaffected.
+     *   - If B is forcefully destroyed, A1 and A2 are unaffected.
+     *
+     *
+     * \sa AggregateObject()
+     */
+    void UnidirectionalAggregateObject(Ptr<Object> other);
+
+    /**
      * Get an iterator to the Objects aggregated to this one.
      *
      * \returns An iterator to the first Object aggregated to this
@@ -436,6 +476,17 @@
      * so the size of the array is indirectly a reference count.
      */
     Aggregates* m_aggregates;
+
+    /**
+     * An array of unidirectional aggregates, i.e., objects that are
+     * aggregated to the current object, but not vice-versa.
+     *
+     * This is useful (and suggested) only for Objects that should
+     * be aggregated to multiple other Objects, where the normal
+     * Aggregation would create an issue.
+     */
+    std::vector<Ptr<Object>> m_unidirectionalAggregates;
+
     /**
      * The number of times the Object was accessed with a
      * call to GetObject().
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/object-ptr-container.h ns-3.42/src/core/model/object-ptr-container.h
--- ns-3.41/src/core/model/object-ptr-container.h	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/object-ptr-container.h	2024-05-29 15:29:46.932073000 -0700
@@ -31,6 +31,11 @@
  * ns3::ObjectPtrContainerValue attribute value declarations and template implementations.
  */
 
+/**
+ * \ingroup attributes
+ * \defgroup attribute_ObjectPtrContainer ObjectPtrContainer Attribute
+ * AttributeValue implementation for ObjectPtrContainer
+ */
 namespace ns3
 {
 
@@ -41,6 +46,12 @@
  *
  * This class it used to get attribute access to an array of
  * ns3::Object pointers.
+ *
+ * \see AttributeValue
+ *
+ * Call graph was not generated because of its size.
+ * \hidecallergraph
+ * \hidecallgraph
  */
 class ObjectPtrContainerValue : public AttributeValue
 {
@@ -146,6 +157,12 @@
 Ptr<const AttributeAccessor> MakeObjectPtrContainerAccessor(INDEX (T::*getN)() const,
                                                             Ptr<U> (T::*get)(INDEX) const);
 
+/**
+ * \ingroup attribute_ObjectPtrContainer
+ *
+ * AttributeChecker implementation for ObjectPtrContainerValue.
+ * \see AttributeChecker
+ */
 class ObjectPtrContainerChecker : public AttributeChecker
 {
   public:
@@ -156,22 +173,28 @@
     virtual TypeId GetItemTypeId() const = 0;
 };
 
+/**
+ * \ingroup attribute_ObjectPtrContainer
+ * \returns The AttributeChecker.
+ * \see AttributeChecker
+ */
 template <typename T>
 Ptr<const AttributeChecker> MakeObjectPtrContainerChecker();
 
 } // namespace ns3
 
-/***************************************************************
- *        The implementation of the above functions.
- ***************************************************************/
+//
+// The implementation of the above functions.
+//
 
 namespace ns3
 {
 
 namespace internal
 {
-
-/** ObjectPtrContainerChecker implementation class. */
+/**
+ * ObjectPtrContainerChecker implementation class.
+ */
 template <typename T>
 class ObjectPtrContainerChecker : public ns3::ObjectPtrContainerChecker
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/pointer.cc ns-3.42/src/core/model/pointer.cc
--- ns-3.41/src/core/model/pointer.cc	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/pointer.cc	2024-05-29 15:29:46.936073000 -0700
@@ -40,7 +40,7 @@
     NS_LOG_FUNCTION(this);
 }
 
-PointerValue::PointerValue(Ptr<Object> object)
+PointerValue::PointerValue(const Ptr<Object>& object)
     : m_value(object)
 {
     NS_LOG_FUNCTION(object);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/ptr.h ns-3.42/src/core/model/ptr.h
--- ns-3.41/src/core/model/ptr.h	2024-02-09 14:44:07.881790000 -0800
+++ ns-3.42/src/core/model/ptr.h	2024-05-29 15:29:46.936073000 -0700
@@ -401,6 +401,9 @@
     }
 };
 
+namespace internal
+{
+
 // Duplicate of struct EventMemberImplObjTraits<T> as defined in make-event.h
 // We repeat it here to declare a specialization on Ptr<T>
 // without making this header dependent on make-event.h
@@ -428,6 +431,8 @@
     }
 };
 
+} // namespace internal
+
 } // namespace ns3
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/scheduler.h ns-3.42/src/core/model/scheduler.h
--- ns-3.41/src/core/model/scheduler.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/scheduler.h	2024-05-29 15:29:46.936073000 -0700
@@ -229,7 +229,7 @@
 };
 
 /**
- * \ingroup Events
+ * \ingroup events
  * Compare (equal) two events by EventKey.
  *
  * \param [in] a The first event.
@@ -243,7 +243,7 @@
 }
 
 /**
- * \ingroup Events
+ * \ingroup events
  * Compare (not equal) two events by EventKey.
  *
  * \param [in] a The first event.
@@ -257,7 +257,7 @@
 }
 
 /**
- * \ingroup Events
+ * \ingroup events
  * Compare (less than) two events by EventKey.
  *
  * Note the invariants which this function must provide:
@@ -272,18 +272,7 @@
 inline bool
 operator<(const Scheduler::EventKey& a, const Scheduler::EventKey& b)
 {
-    if (a.m_ts < b.m_ts)
-    {
-        return true;
-    }
-    else if (a.m_ts == b.m_ts && a.m_uid < b.m_uid)
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return (a.m_ts < b.m_ts || (a.m_ts == b.m_ts && a.m_uid < b.m_uid));
 }
 
 /**
@@ -296,18 +285,7 @@
 inline bool
 operator>(const Scheduler::EventKey& a, const Scheduler::EventKey& b)
 {
-    if (a.m_ts > b.m_ts)
-    {
-        return true;
-    }
-    else if (a.m_ts == b.m_ts && a.m_uid > b.m_uid)
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return (a.m_ts > b.m_ts || (a.m_ts == b.m_ts && a.m_uid > b.m_uid));
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/shuffle.h ns-3.42/src/core/model/shuffle.h
--- ns-3.41/src/core/model/shuffle.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/core/model/shuffle.h	2024-05-29 15:29:46.936073000 -0700
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2024 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef SHUFFLE_H
+#define SHUFFLE_H
+
+/**
+ * \file
+ * \ingroup randomvariable
+ * Function to shuffle elements in a given range.
+ */
+
+#include "random-variable-stream.h"
+
+#include <algorithm>
+#include <iterator>
+
+namespace ns3
+{
+
+/**
+ * Shuffle the elements in the range <i>first</i> to <i>last</i>. Given that the implementation
+ * of std::shuffle is not dictated by the standard
+ * [CppReference](https://en.cppreference.com/w/cpp/algorithm/random_shuffle), it is not guaranteed
+ * that std::shuffle returns the same permutation of the given range using different compilers/OSes.
+ * Therefore, this function provides a specific implementation of the shuffling algorithm reported
+ * in "The Art of Computer Programming" of Donald Knuth and on
+ * [Wikipedia](https://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle#The_modern_algorithm),
+ * which basically matches the implementation in libstdc++.
+ *
+ * The complexity of the implemented algorithm is linear with the distance between <i>first</i>
+ * and <i>last</i>. For containers that do not provide random access iterators (e.g., lists, sets)
+ * we can still achieve a linear complexity by copying the elements in a vector and shuffling the
+ * elements of the vector.
+ *
+ * \tparam RND_ACCESS_ITER \deduced the iterator type (must be a random access iterator)
+ * \param first an iterator pointing to the first element in the range to shuffle
+ * \param last an iterator pointing to past-the-last element in the range to shuffle
+ * \param rv pointer to a uniform random variable
+ */
+template <typename RND_ACCESS_ITER>
+void
+Shuffle(RND_ACCESS_ITER first, RND_ACCESS_ITER last, Ptr<UniformRandomVariable> rv)
+{
+    if (auto dist = std::distance(first, last); dist > 1)
+    {
+        for (--last; first < last; ++first, --dist)
+        {
+            if (auto i = rv->GetInteger(0, dist - 1); i != 0)
+            {
+                std::iter_swap(first, std::next(first, i));
+            }
+        }
+    }
+}
+
+} // namespace ns3
+
+#endif /* SHUFFLE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/simulation-singleton.h ns-3.42/src/core/model/simulation-singleton.h
--- ns-3.41/src/core/model/simulation-singleton.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/simulation-singleton.h	2024-05-29 15:29:46.936073000 -0700
@@ -21,7 +21,7 @@
 
 /**
  * \file
- * \ingroup core
+ * \ingroup singleton
  * ns3::SimulationSingleton declaration and template implementation.
  */
 
@@ -29,7 +29,7 @@
 {
 
 /**
- * \ingroup core
+ * \ingroup singleton
  * This singleton class template ensures that the type
  * for which we want a singleton has a lifetime bounded
  * by the simulation run lifetime. That it, the underlying
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/simulator.h ns-3.42/src/core/model/simulator.h
--- ns-3.41/src/core/model/simulator.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/simulator.h	2024-05-29 15:29:46.936073000 -0700
@@ -426,7 +426,7 @@
      * Note that it is not possible to test for the expiration of
      * events which were scheduled for the "destroy" time. Doing so
      * will result in a program error (crash).
-     * An event is said to "expire" when it starts being scheduled
+     * An event is said to "expire" when it starts being executed,
      * which means that if the code executed by the event calls
      * this function, it will get true.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/singleton.h ns-3.42/src/core/model/singleton.h
--- ns-3.41/src/core/model/singleton.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/singleton.h	2024-05-29 15:29:46.936073000 -0700
@@ -21,7 +21,7 @@
 
 /**
  * \file
- * \ingroup access
+ * \ingroup singleton
  * ns3::Singleton declaration and template implementation.
  */
 
@@ -29,7 +29,14 @@
 {
 
 /**
- * \ingroup access
+ * \ingroup core
+ * \defgroup singleton Singleton
+ *
+ * Template class implementing the Singleton design pattern.
+ */
+
+/**
+ * \ingroup singleton
  * \brief A template singleton
  *
  * This template class can be used to implement the singleton pattern.
